/*
	E񑀍샆[eBeB
	Copyright (C)2000-2002 H.Mutsuki
*/

#include "util.h"
#include "string.h"

/*****************************************************************
*****************************************************************/
_HMC_BEGIN
/*****************************************************************
*****************************************************************/
/*****************************************************************
	mbs<->mbcϊ
*****************************************************************/
UINT mbs2mbc(LPCSTR szChar)
{
	UINT uChar;
	if(_ismbslead(LPBYTE(szChar),LPBYTE(szChar))) {
		uChar = (WORD)(*((LPBYTE)szChar)) << 8;
		uChar |= *(((LPBYTE)szChar)+1);
	} else {
		uChar = (BYTE)*szChar;
	}
	return uChar;
}
void mbc2mbs(UINT uChar, LPSTR szChar)
{
	if(uChar<256) {
		szChar[0] = uChar;
		szChar[1] = '\0';
	} else {
		szChar[0] = (uChar >> 8) &0xff;
		szChar[1] = (uChar >> 0) &0xff;
		szChar[2] = '\0';
	}
}

/*****************************************************************
	ɑSp܂܂Ă邩(Ԃ)
*****************************************************************/
DWORD HaveMBChar(LPCSTR lpText)
{
	DWORD dw=0;
	for(LPCSTR p=lpText; *p;) {
		if(_ismbslead((LPBYTE)lpText,(LPBYTE)p)&&_ismbstrail((LPBYTE)lpText,(LPBYTE)p+1)) {
			dw++;
			p += 2;
		} else {
			p += 1;
		}
	}
	return dw;
}

/*****************************************************************
	p<->Spϊ
*****************************************************************/
static const struct {
	char han;
	char *zen;
} __zen2han_dakuten_tbl__[] = {
	{'',""},
	{'',"K"},{'',"M"},{'',"O"},{'',"Q"},{'',"S"},
	{'',"U"},{'',"W"},{'',"Y"},{'',"["},{'',"]"},
	{'',"_"},{'',"a"},{'',"d"},{'',"f"},{'',"h"},
	{'',"o"},{'',"r"},{'',"u"},{'',"x"},{'',"{"},
};
static const struct {
	char han;
	char *zen;
} __zen2han_handakuten_tbl__[] = {
	{'',"p"},{'',"s"},{'',"v"},{'',"y"},{'',"|"},
};
static const struct {
	char han;
	char *zen;
} __zen2han_tbl__[] = {
	{'0',"O"},{'1',"P"},{'2',"Q"},{'3',"R"},{'4',"S"},{'5',"T"},{'6',"U"},{'7',"V"},{'8',"W"},{'9',"X"},
	{'a',""},{'b',""},{'c',""},{'d',""},{'e',""},{'f',""},{'g',""},{'h',""},{'i',""},{'j',""},{'k',""},{'l',""},{'m',""},{'n',""},{'o',""},{'p',""},{'q',""},{'r',""},{'s',""},{'t',""},{'u',""},{'v',""},{'w',""},{'x',""},{'y',""},{'z',""},
	{'A',"`"},{'B',"a"},{'C',"b"},{'D',"c"},{'E',"d"},{'F',"e"},{'G',"f"},{'H',"g"},{'I',"h"},{'J',"i"},{'K',"j"},{'L',"k"},{'M',"l"},{'N',"m"},{'O',"n"},{'P',"o"},{'Q',"p"},{'R',"q"},{'S',"r"},{'T',"s"},{'U',"t"},{'V',"u"},{'W',"v"},{'X',"w"},{'Y',"x"},{'Z',"y"},
	{' ',"@"},{'!',"I"},{'\"',"h"},{'#',""},{'$',""},{'%',""},{'&',""},{'\'',"f"},{'(',"i"},{')',"j"},{'*',""},{'+',"{"},{',',"C"},{'-',"|"},{'.',"D"},{'/',"^"},
	{':',"F"},{';',"G"},{'<',""},{'=',""},{'>',""},{'?',"H"},{'@',""},{'[',"m"},{'\\',""},{']',"n"},{'^',"O"},{'_',"Q"},{'`',"M"},
	{'{',"o"},{'|',"b"},{'}',"p"},{'~',"`"},
	{'',"A"},{'',"B"},{'',"E"},{'',"J"},{'',"K"},
	{'',"A"},{'',"C"},{'',"E"},{'',"G"},{'',"I"},
	{'',"J"},{'',"L"},{'',"N"},{'',"P"},{'',"R"},
	{'',"T"},{'',"V"},{'',"X"},{'',"Z"},{'',"\"},
	{'',"^"},{'',"`"},{'',"c"},{'',"e"},{'',"g"},
	{'',"i"},{'',"j"},{'',"k"},{'',"l"},{'',"m"},
	{'',"n"},{'',"q"},{'',"t"},{'',"w"},{'',"z"},
	{'',"}"},{'',"~"},{'',""},{'',""},{'',""},
	{'',""},{'',""},{'',""},
	{'',""},{'',""},{'',""},{'',""},{'',""},
	{'',""},{'',""},{'',""},
	{'',"@"},{'',"B"},{'',"D"},{'',"F"},{'',"H"},
	{'',""},{'',""},{'',""},
	{'',"b"},
	{'',"["},
	{'',"u"},
	{'',"v"},
};
DWORD han2zen(LPCSTR lpText, LPSTR lpBuf)
{
	DWORD nRes = 0;
	if(lpBuf) {
		lpBuf[0] = '\0';
	}
	if(lpText && lpBuf && !_ismbblead(*lpText)) {
		// `FbN
		if('0'<=*lpText && *lpText<='9') {
			mbc2mbs(mbs2mbc("O") + (*lpText) - '0', lpBuf);
			nRes = 1;
		}
		// At@xbg啶`FbN
		else if('A'<=*lpText && *lpText<='Z') {
			mbc2mbs(mbs2mbc("`") + (*lpText) - 'A', lpBuf);
			nRes = 1;
		}
		// At@xbg`FbN
		else if('a'<=*lpText && *lpText<='z') {
			mbc2mbs(mbs2mbc("") + (*lpText) - 'a', lpBuf);
			nRes = 1;
		}
		// J^Ji_`FbN
		else if(*(lpText+1)=='') {
			for(int n=0; n<ARRAYLEN(__zen2han_dakuten_tbl__); n++) {
				if(*lpText==__zen2han_dakuten_tbl__[n].han) {
					strcpy(lpBuf,__zen2han_dakuten_tbl__[n].zen);
					nRes = 2;
					break;
				}
			}
		}
		// J^Ji_`FbN
		else if(*(lpText+1)=='') {
			for(int n=0; n<ARRAYLEN(__zen2han_handakuten_tbl__); n++) {
				if(*lpText==__zen2han_handakuten_tbl__[n].han) {
					strcpy(lpBuf,__zen2han_handakuten_tbl__[n].zen);
					nRes = 2;
					break;
				}
			}
		}
		// ̑̕
		else {
			for(int n=0; n<ARRAYLEN(__zen2han_tbl__); n++) {
				if(*lpText==__zen2han_tbl__[n].han) {
					strcpy(lpBuf,__zen2han_tbl__[n].zen);
					nRes = 1;
					break;
				}
			}
		}
		ASSERT(0<nRes);
	}
	return nRes;
}
DWORD zen2han(LPCSTR lpText, LPSTR lpBuf)
{
	DWORD nRes = 0;
	if(lpBuf) {
		lpBuf[0] = '\0';
	}
	if(lpText && lpBuf && _ismbcprint(mbs2mbc(lpText))) {
		// `FbN
		if(mbs2mbc("O")<=mbs2mbc(lpText) && mbs2mbc(lpText)<=mbs2mbc("X")) {
			lpBuf[0] = '0' + mbs2mbc(lpText) - mbs2mbc("O");
			lpBuf[1] = '\0';
			nRes = 2;
		}
		// At@xbg啶`FbN
		else if(mbs2mbc("`")<=mbs2mbc(lpText) && mbs2mbc(lpText)<=mbs2mbc("y")) {
			lpBuf[0] = 'A' + mbs2mbc(lpText) - mbs2mbc("`");
			lpBuf[1] = '\0';
			nRes = 2;
		}
		// At@xbg`FbN
		else if(mbs2mbc("")<=mbs2mbc(lpText) && mbs2mbc(lpText)<=mbs2mbc("")) {
			lpBuf[0] = 'a' + mbs2mbc(lpText) - mbs2mbc("");
			lpBuf[1] = '\0';
			nRes = 2;
		}
		else {
			// J^Ji_`FbN
			if(nRes==0) {
				for(int n=0; n<ARRAYLEN(__zen2han_dakuten_tbl__); n++) {
					if(mbs2mbc(lpText)==mbs2mbc(__zen2han_dakuten_tbl__[n].zen)) {
						lpBuf[0] = __zen2han_dakuten_tbl__[n].han;
						lpBuf[1] = '';
						lpBuf[2] = '\0';
						nRes = 2;
						break;
					}
				}
			}
			// J^Ji_`FbN
			if(nRes==0) {
				for(int n=0; n<ARRAYLEN(__zen2han_handakuten_tbl__); n++) {
					if(mbs2mbc(lpText)==mbs2mbc(__zen2han_handakuten_tbl__[n].zen)) {
						lpBuf[0] = __zen2han_handakuten_tbl__[n].han;
						lpBuf[1] = '';
						lpBuf[2] = '\0';
						nRes = 2;
						break;
					}
				}
			}
			// ̑̕
			if(nRes==0) {
				for(int n=0; n<ARRAYLEN(__zen2han_tbl__); n++) {
					if(mbs2mbc(lpText)==mbs2mbc(__zen2han_tbl__[n].zen)) {
						lpBuf[0] = __zen2han_tbl__[n].han;
						lpBuf[1] = '\0';
						nRes = 2;
						break;
					}
				}
			}
		}
		ASSERT(0<nRes);
	}
	return nRes;
}
DWORD han2zen(LPCSTR lpText, LPSTR lpBuf, DWORD cchBuf)
{
	DWORD nRes = 0;
	char str[3] = {0};
	if(lpBuf) {
		lpBuf[0] = '\0';
	}
	if(lpText && lpBuf && 1<cchBuf) {
		DWORD m = 0;
		for(DWORD n=0; lpText[m]!='\0'&&m<cchBuf-1;) {
			DWORD l = han2zen(&lpText[m],str);
			if(l==0) {
				if(_ismbblead(lpText[m])) {
					lpBuf[n+0] = lpText[m+0];
					lpBuf[n+1] = lpText[m+1];
					lpBuf[n+2] = '\0';
					n += 2;
					m += 2;
				} else {
					lpBuf[n+0] = lpText[m+0];
					lpBuf[n+1] = '\0';
					n += 1;
					m += 1;
				}
			} else {
				DWORD len = strlen(str);
				if(n+len<cchBuf) {
					memcpy(&lpBuf[n],str,len);
					lpBuf[n+len] = '\0';
					n += len;
					m += l;
				} else {
					break;
				}
			}
		}
		nRes = m;
	}
	return nRes;
}
DWORD zen2han(LPCSTR lpText, LPSTR lpBuf, DWORD cchBuf)
{
	DWORD nRes = 0;
	char str[3] = {0};
	if(lpBuf) {
		lpBuf[0] = '\0';
	}
	if(lpText && lpBuf && 1<cchBuf) {
		DWORD m = 0;
		for(DWORD n=0; lpText[m]!='\0'&&m<cchBuf-1;) {
			DWORD l = zen2han(&lpText[m],str);
			if(l==0) {
				if(_ismbblead(lpText[m])) {
					lpBuf[n+0] = lpText[m+0];
					lpBuf[n+1] = lpText[m+1];
					lpBuf[n+2] = '\0';
					n += 2;
					m += 2;
				} else {
					lpBuf[n+0] = lpText[m+0];
					lpBuf[n+1] = '\0';
					n += 1;
					m += 1;
				}
			} else {
				DWORD len = strlen(str);
				if(n+len<cchBuf) {
					memcpy(&lpBuf[n],str,len);
					lpBuf[n+len] = '\0';
					n += len;
					m += l;
				} else {
					break;
				}
			}
		}
		nRes = m;
	}
	return nRes;
}

/*****************************************************************
	J^Ji<->Ђ炪ȕϊ
*****************************************************************/
DWORD kata2hira(LPCSTR lpText, LPSTR lpBuf)
{
	DWORD nRes = 0;
	if(lpBuf) {
		lpBuf[0] = '\0';
	}
	if(lpText && lpBuf && _ismbcprint(mbs2mbc(lpText))) {
		// ʃR[h`FbN
		if(mbs2mbc("@")<=mbs2mbc(lpText) && mbs2mbc(lpText)<=mbs2mbc("~")) {
			mbc2mbs(mbs2mbc(lpText) - (mbs2mbc("@") - mbs2mbc("")), lpBuf);
			nRes = 2;
		} else if(mbs2mbc("")<=mbs2mbc(lpText) && mbs2mbc(lpText)<=mbs2mbc("")) {
			mbc2mbs(mbs2mbc(lpText) - (mbs2mbc("") - mbs2mbc("")), lpBuf);
			nRes = 2;
		}
		// J^Jî݂̕`FbN
		else {
			static const struct {
				char *kata;
				char *hira;
			} a[] = {
				{"","J"},
				{"",""},	// ϊȂ̓}V낤cc
				{"",""},	// ϊȂ̓}V낤cc
			};
			for(int n=0; n<ARRAYLEN(a); n++) {
				if(mbs2mbc(lpText)==mbs2mbc(a[n].kata)) {
					strcpy(lpBuf,a[n].hira);
					nRes = strlen(a[n].kata);
					break;
				}
			}
		}
	}
	return nRes;
}
DWORD hira2kata(LPCSTR lpText, LPSTR lpBuf)
{
	DWORD nRes = 0;
	if(lpText && lpBuf && _ismbcprint(mbs2mbc(lpText))) {
		// ʃR[h`FbN
		if(mbs2mbc("")<=mbs2mbc(lpText) && mbs2mbc(lpText)<=mbs2mbc("")) {
			mbc2mbs(mbs2mbc(lpText) + (mbs2mbc("@") - mbs2mbc("")), lpBuf);
			nRes = 2;
		} else if(mbs2mbc("")<=mbs2mbc(lpText) && mbs2mbc(lpText)<=mbs2mbc("")) {
			mbc2mbs(mbs2mbc(lpText) + (mbs2mbc("") - mbs2mbc("")), lpBuf);
			nRes = 2;
		}
		// J^Jî݂̕`FbN
		else {
			static const struct {
				char *hira;
				char *kata;
			} a[] = {
				{"J",""},
			};
			for(int n=0; n<ARRAYLEN(a); n++) {
				if(strncmp(lpText,a[n].hira,strlen(a[n].hira))==0) {
					strcpy(lpBuf,a[n].kata);
					nRes = strlen(a[n].hira);
					break;
				}
			}
		}
	} else if(lpBuf) {
		lpBuf[0] = '\0';
	}
	return nRes;
}
DWORD kata2hira(LPCSTR lpText, LPSTR lpBuf, DWORD cchBuf)
{
	DWORD nRes = 0;
	char str[5] = {0};
	if(lpText && lpBuf && 1<cchBuf) {
		DWORD m = 0;
		for(DWORD n=0; lpText[m]!='\0'&&m<cchBuf-1;) {
			DWORD l = kata2hira(&lpText[m],str);
			if(l==0) {
				if(_ismbblead(lpText[m])) {
					lpBuf[n+0] = lpText[m+0];
					lpBuf[n+1] = lpText[m+1];
					lpBuf[n+2] = '\0';
					n += 2;
					m += 2;
				} else {
					lpBuf[n+0] = lpText[m+0];
					lpBuf[n+1] = '\0';
					n += 1;
					m += 1;
				}
			} else {
				DWORD len = strlen(str);
				if(n+len<cchBuf) {
					memcpy(&lpBuf[n],str,len);
					lpBuf[n+len] = '\0';
					n += len;
					m += l;
				} else {
					break;
				}
			}
		}
		nRes = m;
	}
	return nRes;
}
DWORD hira2kata(LPCSTR lpText, LPSTR lpBuf, DWORD cchBuf)
{
	DWORD nRes = 0;
	char str[3] = {0};
	if(lpText && lpBuf && 1<cchBuf) {
		DWORD m = 0;
		for(DWORD n=0; lpText[m]!='\0'&&m<cchBuf-1;) {
			DWORD l = hira2kata(&lpText[m],str);
			if(l==0) {
				if(_ismbblead(lpText[m])) {
					lpBuf[n+0] = lpText[m+0];
					lpBuf[n+1] = lpText[m+1];
					lpBuf[n+2] = '\0';
					n += 2;
					m += 2;
				} else {
					lpBuf[n+0] = lpText[m+0];
					lpBuf[n+1] = '\0';
					n += 1;
					m += 1;
				}
			} else {
				DWORD len = strlen(str);
				if(n+len<cchBuf) {
					memcpy(&lpBuf[n],str,len);
					lpBuf[n+len] = '\0';
					n += len;
					m += l;
				} else {
					break;
				}
			}
		}
		nRes = m;
	}
	return nRes;
}

/*****************************************************************
	[}J^Ji(Sp)ϊ
*****************************************************************/
static const struct {
	char *roma;
	char *kana;
} __roma2kana_tbl__[] = {
	// As
	{"wwi","bEB"},{"wwe","bEF"},
	{"vva","b@"},{"vvi","bB"},               {"vve","bF"},{"vvo","bH"},
	{"vvu","b"},
	{"wi","EB"},{"we","EF"},
	{"wha","E@"},{"whi","EB"},        {"whe","EF"},{"who","EH"},
	{"va","@"},{"vi","B"},          {"ve","F"},{"vo","H"},
	{"vu",""},
	{ "a","A"},{ "i","C"},{ "u","E"},{ "e","G"},{ "o","I"},

	// Js
	{"kkya","bL"},{"kkyi","bLB"},{"kkyu","bL"},{"kkye","bLF"},{"kkyo","bL"},
	{"ggya","bM"},{"ggyi","bMB"},{"ggyu","bM"},{"ggye","bMF"},{"ggyo","bM"},
	{ "qqa","bN@"},{ "qqi","bNB"},{ "qqu","bNB"},{ "qqe","bNF"},{ "qqo","bNH"},
	{"kka","bJ"},{"kki","bL"},{"kku","bN"},{"kke","bP"},{"kko","bR"},
	{"gga","bK"},{"ggi","bM"},{"ggu","bO"},{"gge","bQ"},{"ggo","bS"},
	{"kya","L"},{"kyi","LB"},{"kyu","L"},{"kye","LF"},{"kyo","L"},
	{ "qa","N@"},{ "qi","NB"},               { "qe","NF"},{ "qo","NH"},
	{"gya","M"},{"gyi","MB"},{"gyu","M"},{"gye","MF"},{"gyo","M"},
	{"ka","J"},{"ki","L"},{"ku","N"},{"ke","P"},{"ko","R"},
	{"ca","J"},{"cu","N"},{"co","R"},
	{"qu","N"  },
	{"ga","K"},{"gi","M"},{"gu","O"},{"ge","Q"},{"go","S"},

	// Ts
	{"ssya","bV"},{"ssyi","bVB"},{"ssyu","bV"},{"ssye","bVF"},{"ssyo","bV"},
	{"ssha","bV"},                  {"sshu","bV"},{"sshe","bVF"},{"ssho","bV"},
	{ "jja","bW"},                  { "jju","bW"},{ "jje","bWF"},{ "jjo","bW"},
	{"jjya","bW"},{"jjyi","bWB"},{"jjyu","bW"},{"jjye","bWF"},{"jjyo","bW"},
	{"zzya","bW"},{"zzyi","bWB"},{"zzyu","bW"},{"zzye","bWF"},{"zzyo","bW"},
	{"ssa","bT"},{"ssi","bV"},{"ssu","bX"},{"sse","bZ"},{"sso","b\"},
	{"sshi","bV"  },
	{ "jji","bW"  },
	{"zza","bU"},{"zzi","bW"},{"zzu","bY"},{"zze","b["},{"zzo","b]"},
	{"sya","V"},{"syi","VB"},{"syu","V"},{"sye","VF"},{"syo","V"},
	{"sha","V"},               {"shu","V"},{"she","VF"},{"sho","V"},
	{ "ja","W"},               { "ju","W"},{ "je","WF"},{ "jo","W"},
	{"jya","W"},{"jyi","WB"},{"jyu","W"},{"jye","WF"},{"jyo","W"},
	{"zya","W"},{"zyi","WB"},{"zyu","W"},{"zye","WF"},{"zyo","W"},
	{"sa","T"},{"si","V"},{"su","X"},{"se","Z"},{"so","\"},
	{"shi","V"  },
	{ "ji","W"  },
	{"za","U"},{"zi","W"},{"zu","Y"},{"ze","["},{"zo","]"},

	// ^s
	{"ttya","b`"},{"ttyi","b`B"},{"ttyu","b`"},{"ttye","b`F"},{"ttyo","b`"},
	{"ccya","b`"},{"ccyi","b`B"},{"ccyu","b`"},{"ccye","b`F"},{"ccyo","b`"},
	{"ccha","b`"},                  {"cchu","b`"},{"cche","b`F"},{"ccho","b`"},
	{"ttha","be"},{"tthi","beB"},{"tthu","be"},{"tthe","beF"},{"ttho","be"},
	{"ttsa","bc@"},{"ttsi","bcB"},                  {"ttse","bcF"},{"ttso","bcH"},
	{"ddya","ba"},{"ddyi","baB"},{"ddyu","ba"},{"ddye","baF"},{"ddyo","ba"},
	{"ddha","bf"},{"ddhi","bfB"},{"ddhu","bf"},{"ddhe","bfF"},{"ddho","bf"},
	{"tta","b^"},{"tti","b`"},{"ttu","bc"},{"tte","be"},{"tto","bg"},
	{"ttsu","bc"  },
	{"cchi","b`"  },
	{"dda","b_"},{"ddi","ba"},{"ddu","bd"},{"dde","bf"},{"ddo","bh"},
	{"tya","`"},{"tyi","`B"},{"tyu","`"},{"tye","`F"},{"tyo","`"},
	{"cha","`"},               {"chu","`"},{"che","`F"},{"cho","`"},
	{"cya","`"},{"cyi","`B"},{"cyu","`"},{"cye","`F"},{"cyo","`"},
	{"tha","e"},{"thi","eB"},{"thu","e"},{"the","eF"},{"tho","e"},
	{"tsa","c@"},{"tsi","cB"},               {"tse","cF"},{"tso","cH"},
	{"dya","a"},{"dyi","aB"},{"dyu","a"},{"dye","aF"},{"dyo","a"},
	{"dha","f"},{"dhi","fB"},{"dhu","f"},{"dhe","fF"},{"dho","f"},
	{ "ta","^"},{ "ti","`"},{ "tu","c"},{ "te","e"},{ "to","g"},
	{"chi","`"  },
	{"tsu","c"  },
	{ "da","_"},{ "di","a"},{ "du","d"},{ "de","f"},{ "do","h"},

	// is
	{"nya","j"},{"nyi","jB"},{"nyu","j"},{"nye","jF"},{"nyo","j"},
	{"na","i"},{"ni","j"},{"nu","k"},{"ne","l"},{"no","m"},

	// ns
	{"hhya","bq"},{"hhyi","bqB"},{"hhyu","bq"},{"hhye","bqF"},{"hhyo","bq"},
	{"bbya","br"},{"bbyi","brB"},{"bbyu","br"},{"bbye","brF"},{"bbyo","br"},
	{"ppya","bs"},{"ppyi","bsB"},{"ppyu","bs"},{"ppye","bsF"},{"ppyo","bs"},
	{ "ffa","bt@"},{ "ffi","btB"},                  { "ffe","btF"},{ "ffo","btH"},
	{"ffya","bt"},{"ffyi","btB"},{"ffyu","bt"},{"ffye","btF"},{"ffyo","bt"},
	{ "ffu","bt"  },
	{"hha","bn"},{"hhi","bq"},{"hhu","bt"},{"hhe","bw"},{"hho","bz"},
	{"bba","bo"},{"bbi","br"},{"bbu","bu"},{"bbe","bx"},{"bbo","b{"},
	{"ppa","bp"},{"ppi","bs"},{"ppu","bv"},{"ppe","by"},{"ppo","b|"},
	{"hya","q"},{"hyi","qB"},{"hyu","q"},{"hye","qF"},{"hyo","q"},
	{"bya","r"},{"byi","rB"},{"byu","r"},{"bye","rF"},{"byo","r"},
	{"pya","s"},{"pyi","sB"},{"pyu","s"},{"pye","sF"},{"pyo","s"},
	{ "fa","t@"},{ "fi","tB"},               { "fe","tF"},{ "fo","tH"},
	{"fya","t"},{"fyi","tB"},{"fyu","t"},{"fye","tF"},{"fyo","t"},
	{ "fu","t"  },
	{"ha","n"},{"hi","q"},{"hu","t"},{"he","w"},{"ho","z"},
	{"ba","o"},{"bi","r"},{"bu","u"},{"be","x"},{"bo","{"},
	{"pa","p"},{"pi","s"},{"pu","v"},{"pe","y"},{"po","|"},

	// }s
	{"mya","~"},{"myi","~B"},{"myu","~"},{"mye","~F"},{"myo","~"},
	{"ma","}"},{"mi","~"},{"mu",""},{"me",""},{"mo",""},

	// s
	{"yya","b"},{"yyu","b"},{"yyo","b"},
	{"ya",""},{"yu",""},{"yo",""},
	{"yi","C"},{"ye","CF"},

	// s
	{"rrya","b"},{"rryi","bB"},{"rryu","b"},{"rrye","bF"},{"rryo","b"},
	{"rra","b"},{"rri","b"},{"rru","b"},{"rre","b"},{"rro","b"},
	{"rya",""},{"ryi","B"},{"ryu",""},{"rye","F"},{"ryo",""},
	{"ra",""},{"ri",""},{"ru",""},{"re",""},{"ro",""},

	// s
	{"wwa","b"},{"wwo","b"},
	{"wa",""},{"wo",""},
	{"nn",""},

	// As
	{"nwwi","bEB"},{"nwwe","bEF"},
	{"nvva","b@"},{"nvvi","bB"},               {"nvve","bF"},{"nvvo","bH"},
	{"nvvu","b"},
	{"nwi","EB"},{"nwe","EF"},
	{"nva","@"},{"nvi","B"},          {"nve","F"},{"nvo","H"},
	{"nvu",""},
	{"nna","A"},{"nni","C"},{"nnu","E"},{"nne","G"},{"nno","I"},

	// Js
	{"nkkya","bL"},{"nkkyi","bLB"},{"nkkyu","bL"},{"nkkye","bLF"},{"nkkyo","bL"},
	{"nggya","bM"},{"nggyi","bMB"},{"nggyu","bM"},{"nggye","bMF"},{"nggyo","bM"},
	{ "nqqa","bN@"},{ "nqqi","bNB"},                     { "nqqe","bNF"},{ "nqqo","bNH"},
	{"nkka","bJ"},{"nkki","bL"},{"nkku","bN"},{"nkke","bP"},{"nkko","bR"},
	{"ncca","bJ"},{"nccu","bN"},{"ncco","bR"},
	{"nqqu","bN"},
	{"nca","J"},{"ncu","N"},{"nco","R"},
	{"ngga","bK"},{"nggi","bM"},{"nggu","bO"},{"ngge","bQ"},{"nggo","bS"},
	{"nkya","L"},{"nkyi","LB"},{"nkyu","L"},{"nkye","LF"},{"nkyo","L"},
	{ "nqa","N@"},{ "nqi","NB"},                  { "nqe","NF"},{ "nqo","NH"},
	{"ngya","M"},{"ngyi","MB"},{"ngyu","M"},{"ngye","MF"},{"ngyo","M"},
	{"nka","J"},{"nki","L"},{"nku","N"},{"nke","P"},{"nko","R"},
	{"nca","J"},{"ncu","N"},{"nco","R"},
	{"nqu","N"  },
	{"nga","K"},{"ngi","M"},{"ngu","O"},{"nge","Q"},{"ngo","S"},

	// Ts
	{"nssya","bV"},{"nssyi","bVB"},{"nssyu","bV"},{"nssye","bVF"},{"nssyo","bV"},
	{"nssha","bV"},                     {"nsshu","bV"},{"nsshe","bVF"},{"nssho","bV"},
	{ "njja","bW"},                     { "njju","bW"},{ "njje","bWF"},{ "njjo","bW"},
	{"njjya","bW"},{"njjyi","bWB"},{"njjyu","bW"},{"njjye","bWF"},{"njjyo","bW"},
	{"nzzya","bW"},{"nzzyi","bWB"},{"nzzyu","bW"},{"nzzye","bWF"},{"nzzyo","bW"},
	{"nssa","bT"},{"nssi","bV"},{"nssu","bX"},{"nsse","bZ"},{"nsso","b\"},
	{"nsshi","bV"  },
	{"ncci","bV"},{"ncce","bZ"},
	{ "njji","bW"  },
	{"nzza","bU"},{"nzzi","bW"},{"nzzu","bY"},{"nzze","b["},{"nzzo","b]"},
	{"nsya","V"},{"nsyi","VB"},{"nsyu","V"},{"nsye","VF"},{"nsyo","V"},
	{"nsha","V"},                  {"nshu","V"},{"nshe","VF"},{"nsho","V"},
	{ "nja","W"},                  { "nju","W"},{ "nje","WF"},{ "njo","W"},
	{"njya","W"},{"njyi","WB"},{"njyu","W"},{"njye","WF"},{"njyo","W"},
	{"nzya","W"},{"nzyi","WB"},{"nzyu","W"},{"nzye","WF"},{"nzyo","W"},
	{"nsa","T"},{"nsi","V"},{"nsu","X"},{"nse","Z"},{"nso","\"},
	{"nshi","V"  },
	{"nci","V"},{"nce","Z"},
	{ "nji","W"  },
	{"nza","U"},{"nzi","W"},{"nzu","Y"},{"nze","["},{"nzo","]"},

	// ^s
	{"nttya","b`"},{"nttyi","b`B"},{"nttyu","b`"},{"nttye","b`F"},{"nttyo","b`"},
	{"nccya","b`"},{"nccyi","b`B"},{"nccyu","b`"},{"nccye","b`F"},{"nccyo","b`"},
	{"nccha","b`"},                     {"ncchu","b`"},{"ncche","b`F"},{"nccho","b`"},
	{"nttha","be"},{"ntthi","beB"},{"ntthu","be"},{"ntthe","beF"},{"nttho","be"},
	{"nttsa","bc@"},{"nttsi","bcB"},                     {"nttse","bcF"},{"nttso","bcH"},
	{"nddya","ba"},{"nddyi","baB"},{"nddyu","ba"},{"nddye","baF"},{"nddyo","ba"},
	{"nddha","bf"},{"nddhi","bfB"},{"nddhu","bf"},{"nddhe","bfF"},{"nddho","bf"},
	{"ntta","b^"},{"ntti","b`"},{"nttu","bc"},{"ntte","be"},{"ntto","bg"},
	{"nttsu","bc"  },
	{"ncchi","b`"  },
	{"ndda","b_"},{"nddi","ba"},{"nddu","bd"},{"ndde","bf"},{"nddo","bh"},
	{"ntya","`"},{"ntyi","`B"},{"ntyu","`"},{"ntye","`F"},{"ntyo","`"},
	{"ncha","`"},                  {"nchu","`"},{"nche","`F"},{"ncho","`"},
	{"ncya","`"},{"ncyi","`B"},{"ncyu","`"},{"ncye","`F"},{"ncyo","`"},
	{"ntha","e"},{"nthi","eB"},{"nthu","e"},{"nthe","eF"},{"ntho","e"},
	{"ntsa","c@"},{"ntsi","cB"},                  {"ntse","cF"},{"ntso","cH"},
	{"ndya","a"},{"ndyi","aB"},{"ndyu","a"},{"ndye","aF"},{"ndyo","a"},
	{"ndha","f"},{"ndhi","fB"},{"ndhu","f"},{"ndhe","fF"},{"ndho","f"},
	{ "nta","^"},{ "nti","`"},{ "ntu","c"},{ "nte","e"},{ "nto","g"},
	{"nchi","`"  },
	{"ntsu","c"  },
	{ "nda","_"},{ "ndi","a"},{ "ndu","d"},{ "nde","f"},{ "ndo","h"},

	// is
	{"nnnya","j"},{"nnnyi","jB"},{"nnnyu","j"},{"nnnye","jF"},{"nnnyo","j"},
	{"nnna","i"},{"nnni","j"},{"nnnu","k"},{"nnne","l"},{"nnno","m"},

	// ns
	{"nhhya","bq"},{"nhhyi","bqB"},{"nhhyu","bq"},{"nhhye","bqF"},{"nhhyo","bq"},
	{"nbbya","br"},{"nbbyi","brB"},{"nbbyu","br"},{"nbbye","brF"},{"nbbyo","br"},
	{"nppya","bs"},{"nppyi","bsB"},{"nppyu","bs"},{"nppye","bsF"},{"nppyo","bs"},
	{ "nffa","bt@"},{ "nffi","btB"},                     { "nffe","btF"},{ "nffo","btH"},
	{"nffya","bt"},{"nffyi","btB"},{"nffyu","bt"},{"nffye","btF"},{"nffyo","bt"},
	{ "nffu","bt"  },
	{"nhha","bn"},{"nhhi","bq"},{"nhhu","bt"},{"nhhe","bw"},{"nhho","bz"},
	{"nbba","bo"},{"nbbi","br"},{"nbbu","bu"},{"nbbe","bx"},{"nbbo","b{"},
	{"nppa","bp"},{"nppi","bs"},{"nppu","bv"},{"nppe","by"},{"nppo","b|"},
	{"nhya","q"},{"nhyi","qB"},{"nhyu","q"},{"nhye","qF"},{"nhyo","q"},
	{"nbya","r"},{"nbyi","rB"},{"nbyu","r"},{"nbye","rF"},{"nbyo","r"},
	{"npya","s"},{"npyi","sB"},{"npyu","s"},{"npye","sF"},{"npyo","s"},
	{ "nfa","t@"},{ "nfi","tB"},                  { "nfe","tF"},{ "nfo","tH"},
	{"nfya","t"},{"nfyi","tB"},{"nfyu","t"},{"nfye","tF"},{"nfyo","t"},
	{ "nfu","t"  },
	{"nha","n"},{"nhi","q"},{"nhu","t"},{"nhe","w"},{"nho","z"},
	{"nba","o"},{"nbi","r"},{"nbu","u"},{"nbe","x"},{"nbo","{"},
	{"npa","p"},{"npi","s"},{"npu","v"},{"npe","y"},{"npo","|"},

	// }s
	{"nmya","~"},{"nmyi","~B"},{"nmyu","~"},{"nmye","~F"},{"nmyo","~"},
	{"nma","}"},{"nmi","~"},{"nmu",""},{"nme",""},{"nmo",""},

	// s
	{"nyya","b"},{"nyyu","b"},{"nyyo","b"},
	{"nnya",""},{"nnyu",""},{"nnyo",""},
	{"nnyi","C"},{"nnye","CF"},

	// s
	{"nrrya","b"},{"nrryi","bB"},{"nrryu","b"},{"nrrye","bF"},{"nrryo","b"},
	{"nrra","b"},{"nrri","b"},{"nrru","b"},{"nrre","b"},{"nrro","b"},
	{"nrya",""},{"nryi","B"},{"nryu",""},{"nrye","F"},{"nryo",""},
	{"nra",""},{"nri",""},{"nru",""},{"nre",""},{"nro",""},

	// s()
	{"nwwa","b"},{"nwwo","b"},
	{"nwa",""},{"nwo",""},

	// 
	{"nxa","@"},{"nxi","B"},{"nxu","D"},{"nxe","F"},{"nxo","H"},
	{"nla","@"},{"nli","B"},{"nlu","D"},{"nle","F"},{"nlo","H"},
	{"nxka",""},{"nxke",""},
	{"nlka",""},{"nlke",""},

	{"nxa","@"},{"nxi","B"},{"nxu","D"},{"nxe","F"},{"nxo","H"},
	{"nla","@"},{"nli","B"},{"nlu","D"},{"nle","F"},{"nlo","H"},
	{"nxye","F"},
	{"nlye","F"},
	{"nxka",""},{"nxke",""},
	{"nlka",""},{"nlke",""},
	{"nxtu","b"},{"nltu","b"},
	{"nxtsu","b"},{"nltsu","b"},
	{"nxya",""},{"nxyu",""},{"nxyo",""},
	{"nlya",""},{"nlyu",""},{"nlyo",""},
	{"nxwa",""},
	{"nlwa",""},

	// w{łb,m,p̒Ówmx́wxƂĈ
	// ɔfƃJi[}ϊɃw{DɂȂ
	{"mbya","r"},{"mbyi","rB"},{"mbyu","r"},{"mbye","rF"},{"mbyo","r"},
	{"mpya","s"},{"mpyi","sB"},{"mpyu","s"},{"mpye","sF"},{"mpyo","s"},
	{"mbba","bo"},{"mbbi","br"},{"mbbu","bu"},{"mbbe","bx"},{"mbbo","b{"},
	{"mppa","bp"},{"mppi","bs"},{"mppu","bv"},{"mppe","by"},{"mppo","b|"},
	{"mbbya","br"},{"mbbyi","brB"},{"mbbyu","br"},{"mbbye","brF"},{"mbbyo","br"},
	{"mppya","bs"},{"mppyi","bsB"},{"mppyu","bs"},{"mppye","bsF"},{"mppyo","bs"},
	{"mba","o"},{"mbi","r"},{"mbu","u"},{"mbe","x"},{"mbo","{"},
	{"mpa","p"},{"mpi","s"},{"mpu","v"},{"mpe","y"},{"mpo","|"},
	{"mma","}"},{"mmi","~"},{"mmu",""},{"mme",""},{"mmo",""},
	{"mmya","~"},{"mmyi","~B"},{"mmyu","~"},{"mmye","~F"},{"mmyo","~"},

	// ̉߂L̗D
	{"n,","A"},{"n-","["},{"n.","B"},{"n/","E"},
	{"n[","u"},{"n]","v"},
	{"n~","`"},

	{"n,","A"},{"n-","["},{"n.","B"},{"n/","E"},
	{"n[","u"},{"n]","v"},
	{"n~","`"},

	// [}ł͂Ȃ[}͂Ŏgp\ȕ
	{"n0","O"},{"n1","P"},{"n2","Q"},{"n3","R"},{"n4","S"},{"n5","T"},{"n6","U"},{"n7","V"},{"n8","W"},{"n9","X"},
	{"nb",""},{"nc",""},{"nd",""},{"nf",""},{"ng",""},{"nh",""},{"nj",""},{"nk",""},{"nl",""},{"nm",""},{"np",""},{"nq",""},{"nr",""},{"ns",""},{"nt",""},{"nv",""},{"nw",""},{"nx",""},{"ny",""},{"nz",""},
	{"nB","a"},{"nC","b"},{"nD","c"},{"nF","e"},{"nG","f"},{"nH","g"},{"nJ","i"},{"nK","j"},{"nL","k"},{"nM","l"},{"nP","o"},{"nQ","p"},{"nR","q"},{"nS","r"},{"nT","s"},{"nV","u"},{"nW","v"},{"nX","w"},{"nY","x"},{"nZ","y"},
	{"n ","@"},{"n!","I"},{"n\"","h"},{"n#",""},{"n$",""},{"n%",""},{"n&",""},{"n'","f"},{"n(","i"},{"n)","j"},{"n*",""},{"n+","{"},{"n,","C"},{"n-","|"},{"n.","D"},{"n/","^"},
	{"n:","F"},{"n;","G"},{"n<",""},{"n=",""},{"n>",""},{"n?","H"},{"n@",""},
	{"n[","m"},{"n\\",""},{"n]","n"},{"n^","O"},{"n_","Q"},{"n`","M"},
	{"n{","o"},{"n|","b"},{"n}","p"},{"n~","P"},

	// s΍
	{"n\n",""},
	{"n\r",""},

	// ȁwx
	//{"n",""},

	// 
	{"xa","@"},{"xi","B"},{"xu","D"},{"xe","F"},{"xo","H"},
	{"la","@"},{"li","B"},{"lu","D"},{"le","F"},{"lo","H"},
	{"xka",""},{"xke",""},
	{"lka",""},{"lke",""},
	{"xtu","b"},{"ltu","b"},
	{"xtsu","b"},{"ltsu","b"},
	{"xya",""},{"xyu",""},{"xyo",""},
	{"lya",""},{"lyu",""},{"lyo",""},
	{"xye","F"},
	{"lye","F"},
	{"xwa",""},
	{"lwa",""},

	// ̉߂L̗D
	{",","A"},{"-","["},{".","B"},{"/","E"},
	{"[","u"},{"]","v"},
	{"~","`"},

	// [}ł͂Ȃ[}͂Ŏgp\ȕ
	{"0","O"},{"1","P"},{"2","Q"},{"3","R"},{"4","S"},{"5","T"},{"6","U"},{"7","V"},{"8","W"},{"9","X"},
	{"a",""},{"b",""},{"c",""},{"d",""},{"e",""},{"f",""},{"g",""},{"h",""},{"i",""},{"j",""},{"k",""},{"l",""},{"m",""},{"n",""},{"o",""},{"p",""},{"q",""},{"r",""},{"s",""},{"t",""},{"u",""},{"v",""},{"w",""},{"x",""},{"y",""},{"z",""},
	{"A","`"},{"B","a"},{"C","b"},{"D","c"},{"E","d"},{"F","e"},{"G","f"},{"H","g"},{"I","h"},{"J","i"},{"K","j"},{"L","k"},{"M","l"},{"N","m"},{"O","n"},{"P","o"},{"Q","p"},{"R","q"},{"S","r"},{"T","s"},{"U","t"},{"V","u"},{"W","v"},{"X","w"},{"Y","x"},{"Z","y"},
	{" ","@"},{"!","I"},{"\"","h"},{"#",""},{"$",""},{"%",""},{"&",""},{"'","f"},{"(","i"},{")","j"},{"*",""},{"+","{"},{",","C"},{"-","|"},{".","D"},{"/","^"},
	{":","F"},{";","G"},{"<",""},{"=",""},{">",""},{"?","H"},{"@",""},
	{"[","m"},{"\\",""},{"]","n"},{"^","O"},{"_","Q"},{"`","M"},
	{"{","o"},{"|","b"},{"}","p"},{"~","P"},
};
DWORD roma2kana(LPCSTR lpText, LPSTR lpBuf, LPCSTR lpHint, DWORD dwFlags)
{
	DWORD nRes = -1;
	if(lpBuf) {
		lpBuf[0] = '\0';
	}
	if(lpText && lpBuf && !_ismbblead(*lpText)) {
		lpBuf[0] = '\0';
		if(lpHint && *lpHint) {
			if(nRes==-1 && (dwFlags & ROMA2KANA_KANA2HINT_MATCH)) {
				for(int n=0; n<ARRAYLEN(__roma2kana_tbl__); n++) {
					if(strncmp(lpHint,__roma2kana_tbl__[n].kana,strlen(__roma2kana_tbl__[n].kana))==0) {
						if(strncmp(lpText,__roma2kana_tbl__[n].roma,strlen(__roma2kana_tbl__[n].roma))==0) {
							// qgƊSɈvꍇ
							strcpy(lpBuf,__roma2kana_tbl__[n].kana);
							nRes = strlen(__roma2kana_tbl__[n].roma);
							break;
						}
					}
				}
			}
			if(nRes==-1 && (dwFlags & ROMA2KANA_KANA2HINT_PARTIALMATCH)) {
				for(int n=0; n<ARRAYLEN(__roma2kana_tbl__); n++) {
					if(strncmp(lpHint,__roma2kana_tbl__[n].kana,strlen(__roma2kana_tbl__[n].kana))==0) {
						if(strncmp(lpText,__roma2kana_tbl__[n].roma,strlen(lpText))==0) {
							// qgƕIɈvꍇ
							strcpy(lpBuf,__roma2kana_tbl__[n].kana);
							nRes = 0;
							break;
						}
					}
				}
			}
			if(nRes==-1 && (dwFlags & ROMA2KANA_HINT2KANA_MATCH)) {
				for(int n=0; n<ARRAYLEN(__roma2kana_tbl__); n++) {
					if(strncmp(lpHint,__roma2kana_tbl__[n].kana,strlen(lpHint))==0) {
						if(strncmp(lpText,__roma2kana_tbl__[n].roma,strlen(__roma2kana_tbl__[n].roma))==0) {
							// qgƊSɈvꍇ
							strcpy(lpBuf,__roma2kana_tbl__[n].kana);
							nRes = strlen(__roma2kana_tbl__[n].roma);
							break;
						}
					}
				}
			}
			if(nRes==-1 && (dwFlags & ROMA2KANA_HINT2KANA_PARTIALMATCH)) {
				for(int n=0; n<ARRAYLEN(__roma2kana_tbl__); n++) {
					if(strncmp(lpHint,__roma2kana_tbl__[n].kana,strlen(lpHint))==0) {
						if(strncmp(lpText,__roma2kana_tbl__[n].roma,strlen(lpText))==0) {
							// qgƕIɈvꍇ
							strcpy(lpBuf,__roma2kana_tbl__[n].kana);
							nRes = 0;
							break;
						}
					}
				}
			}
		} else {
			for(int n=0; n<ARRAYLEN(__roma2kana_tbl__); n++) {
				if(strncmp(lpText,__roma2kana_tbl__[n].roma,strlen(__roma2kana_tbl__[n].roma))==0) {
					// SɈvꍇ
					strcpy(lpBuf,__roma2kana_tbl__[n].kana);
					nRes = strlen(__roma2kana_tbl__[n].roma);
					break;
				}
			}
		}
	}
	return nRes;
}
DWORD kana2roma(LPCSTR lpText, LPSTR lpBuf, LPCSTR lpHint, DWORD dwFlags)
{
	DWORD nRes = -1;
	if(lpBuf) {
		lpBuf[0] = '\0';
	}
	if(lpText && lpBuf && _ismbblead(*lpText)) {
		if(lpHint && *lpHint) {
			if(nRes==-1 && (dwFlags & KANA2ROMA_ROMA2HINT_MATCH)) {
				for(int n=0; n<ARRAYLEN(__roma2kana_tbl__); n++) {
					if(strncmp(lpHint,__roma2kana_tbl__[n].roma,strlen(__roma2kana_tbl__[n].roma))==0) {
						if(strncmp(lpText,__roma2kana_tbl__[n].kana,strlen(__roma2kana_tbl__[n].kana))==0) {
							// qgƊSɈvꍇ
							strcpy(lpBuf,__roma2kana_tbl__[n].roma);
							nRes = strlen(__roma2kana_tbl__[n].kana);
							break;
						}
					}
				}
			}
			if(nRes==-1 && (dwFlags & KANA2ROMA_ROMA2HINT_PARTIALMATCH)) {
				for(int n=0; n<ARRAYLEN(__roma2kana_tbl__); n++) {
					if(strncmp(lpHint,__roma2kana_tbl__[n].roma,strlen(__roma2kana_tbl__[n].roma))==0) {
						if(strncmp(lpText,__roma2kana_tbl__[n].kana,strlen(lpText))==0) {
							// qgƕIɈvꍇ
							strcpy(lpBuf,__roma2kana_tbl__[n].roma);
							nRes = 0;
							break;
						}
					}
				}
			}
			if(nRes==-1 && (dwFlags & KANA2ROMA_HINT2ROMA_MATCH)) {
				for(int n=0; n<ARRAYLEN(__roma2kana_tbl__); n++) {
					if(strncmp(lpHint,__roma2kana_tbl__[n].roma,strlen(lpHint))==0) {
						if(strncmp(lpText,__roma2kana_tbl__[n].kana,strlen(__roma2kana_tbl__[n].kana))==0) {
							// qgƊSɈvꍇ
							strcpy(lpBuf,__roma2kana_tbl__[n].roma);
							nRes = strlen(__roma2kana_tbl__[n].kana);
							break;
						}
					}
				}
			}
			if(nRes==-1 && (dwFlags & KANA2ROMA_HINT2ROMA_PARTIALMATCH)) {
				for(int n=0; n<ARRAYLEN(__roma2kana_tbl__); n++) {
					if(strncmp(lpHint,__roma2kana_tbl__[n].roma,strlen(lpHint))==0) {
						if(strncmp(lpText,__roma2kana_tbl__[n].kana,strlen(lpText))==0) {
							// qgƕIɈvꍇ
							strcpy(lpBuf,__roma2kana_tbl__[n].roma);
							nRes = 0;
							break;
						}
					}
				}
			}
		} else {
			for(int n=0; n<ARRAYLEN(__roma2kana_tbl__); n++) {
				if(strncmp(lpText,__roma2kana_tbl__[n].kana,strlen(__roma2kana_tbl__[n].kana))==0) {
					// SɈvꍇ
					strcpy(lpBuf,__roma2kana_tbl__[n].roma);
					nRes = strlen(__roma2kana_tbl__[n].kana);
					break;
				}
			}
		}
	}
	return nRes;
}
DWORD roma2kana(LPCSTR lpText, LPSTR lpBuf, DWORD cchBuf, LPCSTR lpHint, DWORD dwFlags)
{
	DWORD nRes = -1;
	char str[7] = {0};
	if(lpBuf) {
		lpBuf[0] = '\0';
	}
	if(lpText && lpBuf && 1<cchBuf) {
		DWORD cHint = lpHint ? strlen(lpHint) : 0;
		DWORD m = 0;
		for(DWORD n=0; lpText[m]!='\0'&&m<cchBuf-1&&(!lpHint||n<cHint);) {
			DWORD l = roma2kana(&lpText[m],str,(lpHint&&*lpHint)?&lpHint[n]:NULL,dwFlags);
			if(dwFlags & ROMA2KANA_REMOVE_ENDOFNN) {
				// I[̏d"n"ppb`
				if(strcmp(&lpText[m],"n")==0) {
					if(roma2kana("nn",str,(lpHint&&*lpHint)?&lpHint[n]:NULL,dwFlags)==2) {
						l = 1;
					}
				}
			}
			if(l!=-1) {
				// ɕϊ(邢̓qgƕv)ꍇ
				DWORD len = strlen(str);
				if(n+len<cchBuf) {
					memcpy(&lpBuf[n],str,len);
					lpBuf[n+len] = '\0';
					n += len;
					m += l;
				} else {
					break;	// ȏϊʂi[łȂꍇ
				}
				if(l==0) {
					break;	// v̏ꍇ
				}
			} else {
				// qgƈvȂꍇ
				if(lpHint && *lpHint) {
					DWORD n = roma2kana(&lpText[m],str,NULL,dwFlags);
					if(n!=-1 || n<0) {
						m = -1;
						break;
					}
				}
				// ϊs\ȏꍇ
				if(_ismbblead(lpText[m])) {
					lpBuf[n+0] = lpText[m+0];
					lpBuf[n+1] = lpText[m+1];
					lpBuf[n+2] = '\0';
					n += 2;
					m += 2;
				} else {
					lpBuf[n+0] = lpText[m+0];
					lpBuf[n+1] = '\0';
					n += 1;
					m += 1;
				}
			}
		}
		nRes = m;
	}
	return nRes;
}
DWORD kana2roma(LPCSTR lpText, LPSTR lpBuf, DWORD cchBuf, LPCSTR lpHint, DWORD dwFlags)
{
	DWORD nRes = -1;
	char str[5] = {0};
	if(lpBuf) {
		lpBuf[0] = '\0';
	}
	if(lpText && lpBuf && 1<cchBuf) {
		DWORD cHint = lpHint ? strlen(lpHint) : 0;
		DWORD n=0,m=0;
		for(; lpText[m]!='\0'&&m<cchBuf-1&&(!lpHint||n<cHint);) {
			DWORD l = kana2roma(&lpText[m],str,(lpHint&&*lpHint)?&lpHint[n]:NULL,dwFlags);
			if(l!=-1) {
				// ɕϊ(邢̓qgƕv)ꍇ
				DWORD len = strlen(str);
				if(n+len<cchBuf) {
					memcpy(&lpBuf[n],str,len);
					lpBuf[n+len] = '\0';
					n += len;
					m += l;
				} else {
					break;	// ȏϊʂi[łȂꍇ
				}
				if(l==0) {
					break;	// v̏ꍇ
				}
			} else {
				// ϊ\qgƈvȂꍇ
				if(lpHint && *lpHint) {
					DWORD n = kana2roma(&lpText[m],str,NULL,dwFlags);
					if(n!=-1 || n<0) {
						m = -1;
						break;
					}
				}
				// ϊłȂꍇ
				if(_ismbblead(lpText[m])) {
					lpBuf[n+0] = lpText[m+0];
					lpBuf[n+1] = lpText[m+1];
					lpBuf[n+2] = '\0';
					n += 2;
					m += 2;
				} else {
					lpBuf[n+0] = lpText[m+0];
					lpBuf[n+1] = '\0';
					n += 1;
					m += 1;
				}
			}
		}
		nRes = m;
		if(dwFlags & KANA2ROMA_REMOVE_ENDOFNN) {
			// I[̏d"n"ppb`
			if(strcmp(&lpBuf[n-2],"nn")==0) {
				if(!lpHint || strcmp(&lpHint[n-2],"nn")!=0) {
					lpBuf[n-1] = '\0';
				}
			}
		}
	}
	return nRes;
}

/*****************************************************************
	擾(csv̂悤ȕ؂eLXgŁACfbNX̕𓾂)
*****************************************************************/
BOOL GetCSVIndexedString(LPCTSTR lpText, TCHAR cDelimiter, DWORD nIndex, LPTSTR lpBuf, DWORD cchBuf, LPDWORD lpdwCopied)
{
	if(lpText && *lpText) {
		TString<0> &tmp = *((TString<0>*)lpText);
		DWORD n=0,s=0,e=0;
		for(;; s=e+1,n++) {
			LPTSTR p = tmp.substring(s).find(cDelimiter);
			if(p) {
				e = p-tmp;
			} else {
				e = tmp.length();
			}
			if(!p||nIndex<=n) break;
		}
		if(n==nIndex) {
			DWORD len = e-s;
			if(lpBuf && cchBuf) {
				len = min(len,cchBuf-1);
				tmp.substring(s).copy_to(lpBuf,len);
			}
			if(lpdwCopied) {
				*lpdwCopied = len;
			}
			return TRUE;
		}
	}
	return FALSE;
}
BOOL GetCSVIndexedString(LPCTSTR lpText, LPCTSTR lpDelimiter, DWORD nIndex, LPTSTR lpBuf, DWORD cchBuf, LPDWORD lpdwCopied)
{
	if(lpText && *lpText) {
		TString<0> &tmp = *((TString<0>*)lpText);
		DWORD cDelimiter = ((TString<0>*)lpDelimiter)->length();
		DWORD n=0,s=0,e=0;
		for(;; s=e+cDelimiter,n++) {
			LPTSTR p = tmp.substring(s).find(lpDelimiter);
			if(p) {
				e = p-tmp;
			} else {
				e = tmp.length();
			}
			if(!p||nIndex<=n) break;
		}
		if(n==nIndex) {
			DWORD len = e-s;
			if(lpBuf && cchBuf) {
				len = min(len,cchBuf-1);
				tmp.substring(s).copy_to(lpBuf,len);
			}
			if(lpdwCopied) {
				*lpdwCopied = len;
			}
			return TRUE;
		}
	}
	return FALSE;
}
BOOL SetCSVIndexedString(LPTSTR lpText, DWORD cchText, TCHAR cDelimiter, DWORD nIndex, LPCTSTR lpString)
{
	if(lpText && cchText) {
		TString<0> &tmp = *((TString<0>*)lpText);
		DWORD n=0,s=0,e=0;
		for(;; s=e+1,n++) {
			LPTSTR p = tmp.substring(s).find(cDelimiter);
			if(p) {
				e = p-tmp;
			} else {
				e = tmp.length();
			}
			if(!p||nIndex<=n) break;
		}
		if(n<nIndex) {
			DWORD cchString = ((TString<0>*)lpString)->length() + 1;
			if(e+nIndex-n+cchString <= cchText) {
				for(; n<nIndex; n++) {
					tmp[e++] = cDelimiter;
				}
				tmp.substring(e).let(lpString);
				return TRUE;
			}
		} else {
			DWORD cString = ((TString<0>*)lpString)->length();
			DWORD len = e-s;
			if(tmp.length()-len+cString <= cchText) {
				tmp.replaceAt(s,len,lpString);
				return TRUE;
			}
		}
	}
	return FALSE;
}
BOOL SetCSVIndexedString(LPTSTR lpText, DWORD cchText, LPCTSTR lpDelimiter, DWORD nIndex, LPCTSTR lpString)
{
	if(lpText && cchText) {
		TString<0> &tmp = *((TString<0>*)lpText);
		DWORD cDelimiter = ((TString<0>*)lpDelimiter)->length();
		DWORD n=0,s=0,e=0;
		for(;; s=e+cDelimiter,n++) {
			LPTSTR p = tmp.substring(s).find(lpDelimiter);
			if(p) {
				e = p-tmp;
			} else {
				e = tmp.length();
			}
			if(!p||nIndex<=n) break;
		}
		if(n<nIndex) {
			DWORD cchString = ((TString<0>*)lpString)->length() + 1;
			if(e+(nIndex-n)*cDelimiter+cchString <= cchText) {
				for(; n<nIndex; n++) {
					tmp.concat(lpDelimiter);
				}
				tmp.concat(lpString);
				return TRUE;
			}
		} else {
			DWORD cString = ((TString<0>*)lpString)->length();
			DWORD len = e-s;
			if(tmp.length()-len+cString <= cchText) {
				tmp.replaceAt(s,len,lpString);
				return TRUE;
			}
		}
	}
	return FALSE;
}
DWORD CountCSVIndexedString(LPCTSTR lpText, TCHAR cDelimiter)
{
	if(lpText && *lpText) {
		TString<0> &tmp = *((TString<0>*)lpText);
		DWORD n=0,s=0,e=0;
		for(;; s=e+1,n++) {
			LPTSTR p = tmp.substring(s).find(cDelimiter);
			if(p) {
				e = p-tmp;
			} else {
				n++;	// Ō̗vfłJEg
				break;
			}
		}
		return n;
	}
	return 0;
}
DWORD CountCSVIndexedString(LPCTSTR lpText, LPCTSTR lpDelimiter)
{
	if(lpText && *lpText) {
		TString<0> &tmp = *((TString<0>*)lpText);
		DWORD cDelimiter = ((TString<0>*)lpDelimiter)->length();
		DWORD n=0,s=0,e=0;
		for(;; s=e+cDelimiter,n++) {
			LPTSTR p = tmp.substring(s).find(lpDelimiter);
			if(p) {
				e = p-tmp;
			} else {
				n++;	// Ō̗vfłJEg
				break;
			}
		}
		return n;
	}
	return 0;
}
DWORD FindCSVIndexedString(LPTSTR lpText, TCHAR cDelimiter, LPCTSTR lpString)
{
	if(lpText && *lpText) {
		TString<0> &tmp = *((TString<0>*)lpText);
		DWORD n=0,s=0,e=0;
		for(;; s=e+1,n++) {
			LPTSTR p = tmp.substring(s).find(cDelimiter);
			if(p) {
				e = p-tmp;
				if(tmp.substring(s).isEqualSubstring(lpString)) {
					return n;
				}
			} else if(tmp.substring(s).isEqual(lpString)) {	// Ō̗vf͓ꈵ
				return n;
			} else {
				return -1;
			}
		}
	}
	return -1;
}
DWORD FindCSVIndexedString(LPTSTR lpText, LPCTSTR lpDelimiter, LPCTSTR lpString)
{
	if(lpText && *lpText) {
		TString<0> &tmp = *((TString<0>*)lpText);
		DWORD cDelimiter = ((TString<0>*)lpDelimiter)->length();
		DWORD n=0,s=0,e=0;
		for(;; s=e+cDelimiter,n++) {
			LPTSTR p = tmp.substring(s).find(lpDelimiter);
			if(p) {
				e = p-tmp;
				if(tmp.substring(s).isEqualSubstring(lpString)) {
					return n;
				}
			} else if(tmp.substring(s).isEqual(lpString)) {	// Ō̗vf͓ꈵ
				return n;
			} else {
				return -1;
			}
		}
	}
	return -1;
}
BOOL RemoveCSVIndexedString(LPTSTR lpText, TCHAR cDelimiter, DWORD nIndex)
{
	if(lpText && *lpText) {
		TString<0> &tmp = *((TString<0>*)lpText);
		DWORD cString = ((TString<0>*)lpText)->length();
		DWORD n=0,s=0,e=0;
		for(;; s=e+1,n++) {
			LPTSTR p = tmp.substring(s).find(cDelimiter);
			if(p) {
				e = p-tmp;
			} else {
				e = cString;
			}
			if(!p||nIndex<=n) break;
		}
		if(n==nIndex) {
			if(s==0) {
				tmp.removeAt(s,e-s+1);
			} else if(e==cString) {
				tmp.removeAt(s-1,e-s+1);
			} else {
				tmp.removeAt(s,e-s+1);
			}
			return TRUE;
		}
	}
	return FALSE;
}
BOOL RemoveCSVIndexedString(LPTSTR lpText, LPCTSTR lpDelimiter, DWORD nIndex)
{
	if(lpText && *lpText) {
		TString<0> &tmp = *((TString<0>*)lpText);
		DWORD cDelimiter = ((TString<0>*)lpDelimiter)->length();
		DWORD cString = ((TString<0>*)lpText)->length();
		DWORD n=0,s=0,e=0;
		for(;; s=e+cDelimiter,n++) {
			LPTSTR p = tmp.substring(s).find(lpDelimiter);
			if(p) {
				e = p-tmp;
			} else {
				e = cString;
			}
			if(!p||nIndex<=n) break;
		}
		if(n==nIndex) {
			if(s==0) {
				tmp.removeAt(s,e-s+cDelimiter);
			} else if(e==cString) {
				tmp.removeAt(s-1,e-s+1);
			} else {
				tmp.removeAt(s,e-s+cDelimiter);
			}
			return TRUE;
		}
	}
	return FALSE;
}
BOOL InsertCSVIndexedString(LPTSTR lpText, DWORD cchText, TCHAR cDelimiter, DWORD nIndex, LPCTSTR lpString)
{
	if(lpText && cchText) {
		TString<0> &tmp = *((TString<0>*)lpText);
		DWORD n=0,s=0,e=0;
		for(;; s=e+1,n++) {
			LPTSTR p = tmp.substring(s).find(cDelimiter);
			if(p) {
				e = p-tmp;
			} else {
				e = tmp.length();
			}
			if(!p||nIndex<=n) break;
		}
		if(n<nIndex) {
			DWORD cchString = ((TString<0>*)lpString)->length() + 1;
			if(e+nIndex-n+cchString <= cchText) {
				for(; n<nIndex; n++) {
					tmp[e++] = cDelimiter;
				}
				tmp.substring(e).let(lpString);
				return TRUE;
			}
		} else {
			DWORD len = ((TString<0>*)lpString)->length();
			if(tmp.length()+len+1 <= cchText) {
				tmp.insertAt(s,len+1);
				tmp.replaceAt(s,len,lpString);
				tmp[s+len] = cDelimiter;
				return TRUE;
			}
		}
	}
	return FALSE;
}
BOOL InsertCSVIndexedString(LPTSTR lpText, DWORD cchText, LPCTSTR lpDelimiter, DWORD nIndex, LPCTSTR lpString)
{
	if(lpText && cchText) {
		TString<0> &tmp = *((TString<0>*)lpText);
		DWORD cDelimiter = ((TString<0>*)lpDelimiter)->length();
		DWORD n=0,s=0,e=0;
		for(;; s=e+1,n++) {
			LPTSTR p = tmp.substring(s).find(lpDelimiter);
			if(p) {
				e = p-tmp;
			} else {
				e = tmp.length();
			}
			if(!p||nIndex<=n) break;
		}
		if(n<nIndex) {
			DWORD cchString = ((TString<0>*)lpString)->length() + 1;
			if(e+nIndex-n+cchString <= cchText) {
				for(; n<nIndex; n++) {
					tmp.substring(e+=cDelimiter).let(lpDelimiter);
				}
				tmp.substring(e).let(lpString);
				return TRUE;
			}
		} else {
			DWORD len = ((TString<0>*)lpString)->length();
			if(tmp.length()+len+cDelimiter <= cchText) {
				tmp.insertAt(s,len+cDelimiter);
				tmp.replaceAt(s,len,lpString);
				tmp.replaceAt(s+len,len,lpDelimiter);
				return TRUE;
			}
		}
	}
	return FALSE;
}

/*****************************************************************
*****************************************************************/
_HMC_END
/*****************************************************************
*****************************************************************/

/* Local Variables:						*/
/* tab-width:4							*/
/* c-basic-offset:4						*/
/* c-indent-level:4						*/
/* c-label-offset:-4					*/
/* c-continued-statement-offset:4		*/
/* file-coding-system:*sjis*dos			*/
/* buffer-file-coding-system:sjis-dos	*/
/* End:									*/
